//
//  Red5StreamPlayerView.m
//  red5pro
//
//  Created by Jaydip Godhani on 23/11/21.
//

#import "Red5StreamPlayerView.h"
#import "Red5ProStreamPlayerController.h"

@implementation Red5StreamPlayerView {
    UIView *_view;
    
    int bufferTime;
    double frameWidth;
    double frameHeight;
    
    NSString *streamName;
    NSString *strContextName;
    NSString *strHostName;
    NSString *strLicencekey;
    NSString *strPort;
    NSInteger protocol;
    
    Red5ProStreamPlayerController *controller;
}

- (instancetype)initWithFrame:(CGRect)frame
               viewIdentifier:(int64_t)viewId
                    arguments:(id _Nullable)args
              binaryMessenger:(NSObject<FlutterBinaryMessenger>*)messenger {
    NSDictionary *dictArgs = (NSDictionary *)args;
    
    //frameWidth = [[dictArgs valueForKey:@"width"] doubleValue];
    //frameHeight = [[dictArgs valueForKey:@"height"] doubleValue];
    
    frameWidth = 300;
    frameHeight = 500;
    
    strContextName = [dictArgs valueForKeyPath:@"configuration.contextName"];
    strHostName = [dictArgs valueForKeyPath:@"configuration.host"];
    strLicencekey = [dictArgs valueForKeyPath:@"configuration.licenseKey"];
    strPort = [dictArgs valueForKeyPath:@"configuration.port"];
    protocol = [[dictArgs valueForKeyPath:@"configuration.protocol"] integerValue];
    streamName = [dictArgs valueForKey:@"streamName"];
    
    if (self = [super init]) {
        _view = [[UIView alloc] init];
        
        NSString *strHandlerChannelName = [NSString stringWithFormat:@"Red5StreamPlayerView/%lld",viewId];
        FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:strHandlerChannelName binaryMessenger:messenger];
        
        controller = [[Red5ProStreamPlayerController alloc] init];
        _view.frame = controller.view.frame;
        controller.frameWidth = frameWidth;
        controller.frameHeight = frameHeight;
        controller.strContextName = strContextName;
        controller.strHostName = strHostName;
        controller.strLicencekey = strLicencekey;
        controller.strPort = strPort;
        controller.protocol = protocol;
        controller.strStreamName = streamName;
        controller.viewId = viewId;
        controller.channel = channel;
        [controller setupConfiguration];
        [self.view addSubview:controller.view];
        
        
        [channel setMethodCallHandler:^(FlutterMethodCall * _Nonnull call, FlutterResult  _Nonnull result) {
            if ([call.method isEqualToString:@"play"]) {
                [self->controller startStream];
                result(@(YES));
            } else if ([call.method isEqualToString:@"stop"]) {
                [self->controller stopStream];
                result(@(YES));
            }
        }];
        
    }
    return self;
}

- (UIView*)view {
  return _view;
}

@end
